% This program is created by Katia Stanimirova.

?-
   window( title("Bitmaps and Icons"), size(375, 400)).

win_func(init):-
	bitmap( pos(50, 50) ),
     bitmap( pos(250, 50) ),
     bitmap( pos(100, 100) ), 
     bitmap( pos(200, 100) ),
     bitmap( pos(50, 150) ),
     bitmap( pos(150, 150) ), 
     bitmap( pos(250, 150) ),
     bitmap( pos(100, 200) ),              
     bitmap( pos(200, 200) ),
     bitmap( pos(150, 250) ),
     icon( pos(165, 215) ),
     icon( pos(165, 115) ),
     icon( pos(110,70) ),
     icon( pos(220, 70) ),
     icon( pos(30,112) ),
     icon( pos(300,110) ),
     icon( pos(112,170) ),
     icon( pos(70,115) ),
     icon( pos(265,115) ),
     icon( pos(210,170) ),
     icon( pos(23,76) ),
     icon( pos(305,72) ),
     G_Br:=0,      % G_Br is a global variable (it begin with G_)
     menu( normal, action(menu_brush), text("&Brush") ).

menu_brush(press) :- 
     new_brush(G_Br),
     update_window(_),
     G_Br:= (G_Br+1) mod 5.

new_brush(0) :- window_brush(_, rgb(0, 0, 0), shape(x)).
new_brush(1) :- window_brush(_, rgb(255, 0, 255), shape('/')).
new_brush(2) :- window_brush(_, "res/Wall.bmp").
new_brush(3) :- window_brush(_, rgb(127, 0, 127)).
new_brush(4) :- window_brush(_, _).

