% Reads and prints itself.

?-
  F is open("..//AI//AI 1.spj", "r"),
  _ is get(F, b), % warning=1
  _ is get(F, b), % version=2
  Int:=get(F, b),
  Str:=get(F, b),
  jump_int(F,Int),
  jump_str(F,Str),
  FilesList:=get(F, l),
  jump_str(F,FilesList),
  jump_byte(F,744),
  do(F),
  close(F).

jump_byte(F,Byte):-
  for(I, 1, Byte),
    _ is get(F, b),
  fail.
jump_byte(F,Byte).

jump_int(F,Int):-
  for(I, 1, Int),
    _ is get(F, l),
  fail.
jump_int(F,Int).

jump_str(F,Str):-
  for(I, 1, Str),
    jump_one_str(F),
  fail.
jump_str(F,Str).

jump_one_str(F):-
  (get(F, b)=\=255; get(F, b)=\=254; get(F, b)=\=255->
    write("CString error"),nl
  ),
  Size:=get(F, b),
  (Size=:=0xff -> Size:=get(F, s)),
  (Size=:=0xffff -> Size:=get(F, l)),
  for(I, 1, Size),
    _ is get(F, s),
  fail.
jump_one_str(F).

do(F):-
  S := readln(F), % try with readf
  write(S).
%  fail.
%do(_).

