% This program is made by Plamen Sharapanov

?-
  SourceFile is "http://rss.news.yahoo.com/rss/topstories",
  StyleFile is get_current_directory() + "\\rss.xsl",
  OutputFile is get_current_directory() + "\\rss.html",
  % Load the XML
  Source is server("MSXML2.DOMDocument"),
  Source.'async' := 0,
  Res1 is Source.'load'( SourceFile ),
  Res1,
  % Load the XSLT
  Style is server("MSXML2.DOMDocument"),
  Style.'async' := 0,
  Res2 is Style.'load'(StyleFile),
  Res2,
  % make transformation
  X is Source.'transformNode'(Style),
  % clean up XML/XSL
  close(Style),
  close(Source),
  % save result to disk
  FSO is server("Scripting.FileSystemObject"),
  F is FSO.'OpenTextFile'(OutputFile,2,1,-2),
  F.'Write'(X),
  F.'Close'(),
  % clean up FSO/F
  close(F),
  close(FSO),
  % open resulting html in default browser
  shell_execute(OutputFile),
  nl,write("END"),nl.

