?-
  Search:= "button",

  write("We are looking for \""+Search+"\"", font_mask(color(rgb(255,0,0)))), nl,
  %Dir := select_file(o, _, "All Files (*.*)\0*.*\0"),
  Dir := prolog_path+"\\",
  N:=0, G_Old_File:=0,
  R_Dir := find_all_sub_dirs(Dir, ""),
  (
    F_Name := find_file(Dir+R_Dir+"\\*.add", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r")
  ;
    F_Name := find_file(Dir+R_Dir+"\\*.spj", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r"),
    jump_over_SPJ_head(H_File)
  ;
    F_Name := find_file(Dir+R_Dir+"\\*.pro", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r")
  ),
  (G_Old_File\=0 -> close(G_Old_File)),
  G_Old_File:=H_File,
  Temp:=0,
  Line := readln(H_File),
  one_string(Search, Line),
  (Temp=0->
    Temp:=1,
    N:=N+1,
    nl, write(N+". "+R_Dir+F_Name, font_mask(color(rgb(0,127,0)))), nl
  ),
  write(Line),
  fail.
?-
  (G_Old_File\=0 -> close(G_Old_File)).

R is find_all_sub_dirs(Dir, Path):-
  (R:=Path;
  F := find_file(Dir+Path+"*.*", type(directory)),
  F \= ".", F \= "..",
  R:=find_all_sub_dirs(Dir, Path+F+"\\")).

one_string(Search, Line):-
  sub_string(Search, Line, _, _), % _no (no case)
  !.

jump_over_SPJ_head(F):-
  _ is get(F, b), % warning=1
  _ is get(F, b), % version=2
  Int:=get(F, b),
  Str:=get(F, b),
  jump_int(F,Int),
  jump_str(F,Str),
  FilesList:=get(F, l),
  jump_str(F,FilesList),
  jump_byte(F,744).

jump_byte(F,Byte):-
  for(I, 1, Byte),
    _ is get(F, b),
  fail.
jump_byte(F,Byte).

jump_int(F,Int):-
  for(I, 1, Int),
    _ is get(F, l),
  fail.
jump_int(F,Int).

jump_str(F,Str):-
  for(I, 1, Str),
    jump_one_str(F),
  fail.
jump_str(F,Str).

jump_one_str(F):-
  (get(F, b)=\=255; get(F, b)=\=254; get(F, b)=\=255->
    write("CString error", font_mask(color(rgb(255,0,0)))),nl
  ),
  Size:=get(F, b),
  (Size=:=0xff -> Size:=get(F, s)),
  (Size=:=0xffff -> Size:=get(F, l)),
  for(I, 1, Size),
    _ is get(F, s),
  fail.
jump_one_str(F).

